<template>
  <v-row justify="center">
    <v-card class="mt-4">
      <v-card-title class="justify-center" primary-title>
        <h2>Courses</h2>
      </v-card-title>
      <v-card-text>
        <v-row>
          <v-col
            v-for="course in courses.courses"
            :key="course.title"
            cols="12"
            md="3"
            lg="3"
            sm="6"
          >
            <v-card>
              <v-card-title style="word-break: break-word">
                <v-img :src="course.picture"> </v-img>
                {{ course.title }}
              </v-card-title>
              <v-card-subtitle v-model="courseSelected">
                {{ course.description }}
              </v-card-subtitle>
              <v-card-text> </v-card-text>
              <v-list-item class="grow">
                <v-list-item-avatar color="grey darken-3">
                  <v-img
                    class="elevation-6"
                    :alt="course.title"
                    :src="course.author_picture"
                  ></v-img>
                </v-list-item-avatar>
                <v-list-item-content>
                  <v-list-item-title>{{ course.author }}</v-list-item-title>
                  <small>{{ course.price }}</small>
                </v-list-item-content>
                <v-btn
                  color="success"
                  @click="selectCourse(course.title, course.price)"
                  >Enroll</v-btn
                >
              </v-list-item>
            </v-card>
          </v-col>
        </v-row>
      </v-card-text>
    </v-card>
    <v-dialog v-model="dialog" scrollable max-width="600px">
      <v-card>
        <v-card-title>Enroll in the Course</v-card-title>
        <v-divider></v-divider>
        <v-card-text style="height: 600px;">
          <v-container>
            <v-text-field
              v-model="student.firstname"
              label="First name"
              required
            ></v-text-field>

            <v-text-field
              v-model="student.lastname"
              label="Last name"
              required
            ></v-text-field>

            <v-text-field
              v-model="student.email"
              label="E-mail"
              required
            ></v-text-field>

            <v-text-field
              v-model="student.address"
              label="Address"
              required
            ></v-text-field>

            <v-text-field
              v-model="student.creditcard"
              label="Credit Card Number"
              required
            ></v-text-field>
          </v-container>
        </v-card-text>
        <v-divider></v-divider>
        <v-card-actions>
          <v-btn color="blue darken-1" text @click="dialog = false">
            Close
          </v-btn>
          <v-btn color="blue darken-1" text @click="enrollStudent">
            Enroll
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <v-snackbar v-model="snack" :timeout="3000" :color="snackColor">
      {{ snackText }}
      <template v-slot:action="{ attrs }">
        <v-btn v-bind="attrs" text @click="snack = false">
          Close
        </v-btn>
      </template>
    </v-snackbar>
  </v-row>
</template>
<script>
import axios from "axios";
import { mapActions, mapGetters } from "vuex";

export default {
  data() {
    return {
      snack: false,
      snackColor: "",
      snackText: "",
      courseSelected: { title: "", price: "" },
      student: {
        firstname: "Sam",
        lastname: "Gabrail",
        email: "me@email.com",
        address: "1234 Main St",
        creditcard: "1234-5678-9012-3456"
      },
      dialog: false
    };
  },
  mounted() {
    this.getCourses();
  },
  computed: {
    ...mapGetters(["courses", "students"])
  },
  methods: {
    ...mapActions(["getCourses", "getStudents"]),
    selectCourse(title, price) {
      this.dialog = true;
      this.courseSelected.title = title;
      this.courseSelected.price = price;
      console.log("Course Selected: ", this.courseSelected);
    },
    enrollStudent() {
      this.dialog = false;
      console.log("Student Enrolled: ", this.courseSelected, this.student);
      axios
        .post(
          `${process.env.VUE_APP_API_ADDRESS}/students/${this.courseSelected.title}`,
          this.student,
          {}
        )
        .then(res => {
          console.log("my returned res", res.data);
          this.getStudents();
          this.getCourses();
          if (res.data.success) {
            this.snack = true;
            this.snackColor = "success";
            this.snackText = `Enrolled in the ${this.courseSelected.title} Course Successfully!`;
          } else {
            this.snack = true;
            this.snackColor = "error";
            this.snackText = "Already enrolled in this course";
          }
        })
        .catch(err => console.log(err));
    }
  }
};
</script>
